# en
## intro
I work in Noble Scripts[](https://noblescripts.com/) where we build a template generator for Shopify-powered apps. Thanks to [20% rule](https://en.wikipedia.org/wiki/Side_project_time) I contributed my spare time to working for the Norcivilian Labs [](https://norcivilianlabs.org/). NL builds open source software and provides teaching and mentoring to engineers. I've already worked with NL in the fall and I found inspiration and a lot of new experience. You can see report on that month in my previous post. https://medium.com/@brs.team.dota/csvs-nodejs-e3962e7e3f40

In December our UX designer created two dozen issues for improving the user interface. I took up working on them with oversight from my mentor. There were three big steps - creating a new search bar component, fixing several bugs in the sidebar HTML form that we call a "profile", and improving accessibility in the overview screen.

Right before starting this sprint, I performed a large refactor of the project structure for the future developing branch. Iransferred all files, renamed folders, and repaired imports and connections between the components according to the specification. The PR had 300 changes! [](https://gitlab.com/norcivilian-labs/evenor/-/issues/47). But when the refactor was done at several points during this work, when I changed something, I found small bugs, created issues for them on Gitlab and closed them later along the way.

## search bar
The refactor started with the search bar. By default evenor fetches all records from the csvs database, and the search bar allows to filter those search results. We used to have a search bar that would add search queries to a list. [screenshot of old filter] A new and improved component would consist of a list of search queries that could be edited interactively. [] 

I added a "plus" button that displays a list of categories by which you can search for data in the database. I added a list, it was not displayed in the url, in the list when I wrote something this category should have been displayed, but when I wrote something I got a bunch of duplicate categories, and I had to write filters so that in a specific project if there is a category, then this category should have been displayed. When I entered something into the search field, the characters in the URL bar were not updated. When you type a character, it is added to the URL. We use URLSearchParams to mirror the search in the app so that users can save their searches and share with others.

When this was finished, I discovered a bug in the search stream implementation. We use a stream in evenor to get data from the database in electron thread, and pass it over to the renderer thread as messages. Each time a search bar started a new stream, the old stream was supposed to interrupt and cancel, but the interrupt didn't happen fast enough and some data from the first stream bled into the next one. I had to work together with my mentor on this one. First we improved the logic of the interrupt using [AbortSignal](https://developer.mozilla.org/en-US/docs/Web/API/AbortSignal). And then we realized that we had several asynchronous functions in between stream initiation and interruption. After moving the interrupt higher in the execution queue the streams got fixed.

I also made it so that the input fields in the profile provided suggestions according to the values in the search bar. So that when user searches for the name "Bob" and adds a new record, the input field for name suggested "Bob" as a value.
## profile
In the evenor profile we view and edit a chosen database record. Several pieces of this view were only useful to developers, and could be hidden by default to not distract users.

First was the database schema, sort of a diagram of all the main data, an object with fields that are possible in each record. It was displayed in the default screen, but I needed to only show it only in the optional "settings" screen. We differentiate between the default screen and the settings screen by the value of a repoUUID variable. On the default screen, the UUID is hardcoded as "root", and inside the project settings, the UUID is equal to the UUID of the project. I added an exception for the case when the project settings were open and hid the component in other cases. I also hid the label that showed the project UUID under a spoiler and added a plain text description with i18n internationalization. [screenshot of a spoiler] Next I changed the "upload file" button so that it was no longer visible after uploading a file. There was also a dropdown that showed all possible array values for the array data type inside a record - it was not used for anything at the moment so I hid it entirely. Last, I replaced a dropdown with a button in cases when the dropdown could only have one field - for example when the array record field had only one type of elements. 

## overview
The overview component lists all database records. Evenor has several options for the overview, I implemented one last summer, which looked like an interactive list, and it needed improvements. I added buttons to "edit record", "delete record", "add record" buttons and a tooltip that showed a short description of the record without the need to open it in the profile. [screenshot of the new list overview with a tooltip] Next, I debugged and fixed the radio buttons that changed the type of overview, they would go out of sync on changing projects. I added a subscription to the repoUUID variable to a useEffect inside the radio buttons and synchronization worked as expected.

## conclusion

Over the past two months I felt strong development in my skills. I learned to follow the paths of code execution and document them in Gitlab issues, asked a lot of open questions from my mentor and searched library documentation online. When I asked questions and wrote down plans of work, it was much easier to work. Whenever I got confused, I could take a step back and read the plan again. The most difficult task was to implement a search bar, and a big challenge for me was to formulate questions and make notes.
